#if !defined(_ADATA_ADMXRC3_PORTABILITY_H)
#define _ADATA_ADMXRC3_PORTABILITY_H

/*
** File: portability.h  
** Project: ADMXRC3 API module library
** Purpose: Defines portability functions used by ADMXRC3 API module library
**
** (C) Copyright Alpha Data 2010
*/

#include "platform.h"

extern portable_file_t
portableFileOpenA(
  const char* pFileName,
  bool_t bWrite);

extern portable_file_t
portableFileOpenW(
  const wchar_t* pFileName,
  bool_t bWrite);

extern void
portableFileClose(
  portable_file_t hFile);

extern bool_t
portableFileGetSize(
  portable_file_t hFile,
  uint64_t* pSize);

extern bool_t
portableFileRead(
  portable_file_t hFile,
  void* pBuffer,
  uint64_t n,
  uint64_t* pNumRead);

extern bool_t
portableFileSetPointer(
  portable_file_t hFile,
  uint64_t offset);

extern void
portableStringCat(
  char* pDst,
  size_t max,
  const char* pSrc);

extern void
portableStringCopy(
  char* pDst,
  size_t max,
  const char* pSrc);

extern void
portableStringLower(
  char* pString,
  size_t bufSize);

extern void
portableStringUpper(
  char* pString,
  size_t bufSize);

extern int
portableStringCompareA(
  const char* pString1,
  const char* pString2);

extern int
portableStringCompareW(
  const wchar_t* pString1,
  const wchar_t* pString2);

extern void
portableUTF8ToWideChar(
  wchar_t* pBuffer,
  size_t bufferSize,
  const char* pAnsiString);

#endif
