/*
** File: admxrc2.h  
** Project: ADB3 core driver
** Purpose: Definitions specific to ADM-XRC-II
**
** (C) Copyright Alpha Data 2009-2010
*/

#if !defined(_ADATA_CORE_ADMXRC2_H)
#define _ADATA_CORE_ADMXRC2_H

#pragma pack(1)
typedef struct _ModelRegsAdmxrc2 {
  uint8_t fcon;
  uint8_t ccon;
  uint8_t imset;
  uint8_t imclr;
  uint8_t icon;
  uint8_t pstat;
  uint8_t mode;
  uint8_t flpage;
  uint8_t smap[8];
} ModelRegsAdmxrc2;
#pragma pack()

/* Fields for ModelRegsAdmxrc2::fcon */
#define ADMXRC2_FCON_PROG (1U << 0)
#define ADMXRC2_FCON_INIT (1U << 1)
#define ADMXRC2_FCON_DONE (1U << 2)

/* Fields for ModelRegsAdmxrc2::icon register */
#define ADMXRC2_ICON_FPGA (0x1U << 0)

/* Always LITTLE ENDIAN when stored in hardware */
#pragma pack(1)
typedef struct _VpdAdmxrc2Rev0 {
  uint16_t model;         /* 3 => ADM-XRC-II */
  uint16_t modifications; /* Bitmap; nothing defined yet */
  uint16_t refClock;      /* 1 => 14.31818MHz */
  uint16_t flashType;     /* 2 => Common Flash Interface (CFI) device */
  uint8_t  zbt01;         /* ZBT size & type information for banks 0 to 3 */
  uint8_t  zbt23;         /* ZBT size & type information for banks 0 to 3 */
  uint8_t  zbt45;         /* ZBT size & type information for banks 4 to 5 */
  uint8_t  _reserved1;
  uint16_t cardId;        /* Card ID */
  uint16_t fpgaType;      /* Device fitted; see ADMXRC3_FPGA_TYPE */
  uint32_t serialNumber;  /* Serial number */
  uint8_t  cpldRev;       /* CPLD revision */
  uint8_t  pcbRev;        /* Board revision */
} VpdAdmxrc2Rev0;
#pragma pack()

#endif
