/*
** File: device_defs.h  
** Project: ADB3 core driver
** Purpose: Centralizes location of important definitions for the ADB3 core
**          driver, such as constants, default values for parameters etc.
**
** (C) Copyright Alpha Data 2009-2010
*/

#if !defined(_ADATA_CORE_DEVICE_DEFS_H)
#define _ADATA_CORE_DEVICE_DEFS_H

/*
** PLX Tech PCI9080/PCI9656-based cards
*/
#define PCI_VENDOR_PLXTECH                      (0x10B5)
#define PCI_DEVICE_PLXTECH_PCI9080              (0x9080)
#define PCI_DEVICE_PLXTECH_PCI9656              (0x9656)

#define PCI_SUBVENDOR_PLXTECH                   (0x10B5)
#define PCI_SUBDEVICE_PLXTECH_PCI9080           (0x9080)
#define PCI_SUBDEVICE_PLXTECH_PCI9656           (0x9656)

#define PCI_SUBVENDOR_PCI9656_ADATA             (0x4144)
#define PCI_SUBDEVICE_PCI9656_ADMXRC2           (0x0042)

/*
** Alpha Data ADB3-based cards
*/

#define PCI_VENDOR_ADATA                        (0x4144)
#define PCI_DEVICE_ADATA_ADB3                   (0xADB3)

#define PCI_SUBVENDOR_ADB3_ADATA                (0x4144)
#define PCI_SUBDEVICE_ADB3_GENERIC              (0xADB3)
#define PCI_SUBDEVICE_ADB3_ADPEXRC5T            (0x0100)
#define PCI_SUBDEVICE_ADB3_ADMXRC6TL_LX50T      (0x0200)
#define PCI_SUBDEVICE_ADB3_ADMXRC6TL_FX50T      (0x0201)

/* Default value if DmaMapLength registry parameter not found */
#define DEFAULT_DMA_MAP_LENGTH                  (32)

#endif
