/*
** File: interrupt.c  
** Project: ADB3 core driver
** Purpose: OS-independent functions related to handling of interrupts.
**
** (C) Copyright Alpha Data 2009-2010
*/

#include <df.h>

#include "device.h"
#include "interrupt.h"

void
fpgaInterruptDpc(
  DfDpc* pDpc,
  void* pContext,
  void* pArg)
{
  Adb3CoreDeviceContext* pDevCtx = (Adb3CoreDeviceContext*)pContext;
  unsigned int targetIndex = (unsigned int)(uintptr_t)pArg;
  CoreNotification* pNotification;
  DfSpinLockFlags f;

  f = dfSpinLockGet(&pDevCtx->notification.fpgaInterrupt[targetIndex].lock);
  pNotification = pDevCtx->notification.fpgaInterrupt[targetIndex].pHead;
  while (NULL != pNotification) {
    pNotification->system.pCallback(pNotification, CORE_NOTIFY_FPGA_INTERRUPT(targetIndex), pNotification->system.pCallbackContext);
    pNotification = pNotification->system.pNext;
  }
  dfSpinLockPut(&pDevCtx->notification.fpgaInterrupt[targetIndex].lock, f);
}
