/*
** File: dfcommon.h  
** Project: Driver Framework
** Purpose: Platform-independent definitions
**
** (C) Copyright Alpha Data 2009-2010
*/

#if !defined(ADATA_DF_DFCOMMON_H)
#define ADATA_DF_DFCOMMON_H

#define DF_OFFSET_OF(STRUCT, MEMBER) \
  ((size_t)&((STRUCT*)0)->MEMBER)

#define DF_CONTAINER_OF(VARIABLE, STRUCT, MEMBER) \
  ((STRUCT*)((uint8_t*)(VARIABLE) - DF_OFFSET_OF(STRUCT, MEMBER)))

/* Aligns a pointer to specified alignment */
#define dfAlignPointer(x, align) \
	(void*)(((uintptr_t)(x)) & ~(uintptr_t)((align) - 1U))

/* Returns offset by which a pointer is misaligned to specified alignment */
#define dfPointerAlignment(x, align) \
	(((uintptr_t)(x)) & (uintptr_t)((align) - 1U))

#define DF_ARRAY_LENGTH(x) (sizeof(x) / sizeof((x)[0]))

#endif
