/*
** File: dma.h  
** Project: ADMXRC3 module driver
** Purpose: Defines function prototypes for DMA IOCTL handlers.
**
** (C) Copyright Alpha Data 2009
*/

#if !defined(ADATA_ADMXRC3_DMA_H)
#define ADATA_ADMXRC3_DMA_H

#include <df.h>
#include "device.h"

extern DfIoStatus
ioctlReadDma(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlReadDmaThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlReadDmaLocked(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlReadDmaLockedThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDma(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDmaThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDmaLocked(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDmaLockedThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern void
cleanupDma(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx);

#endif
