/*
** File: event.h  
** Project: ADMXRC3 module driver
** Purpose: Defines function prototypes for event registration and wait IOCTL handlers.
**
** (C) Copyright Alpha Data 2009-2010
*/

#if !defined(ADATA_ADMXRC3_EVENT_H)
#define ADATA_ADMXRC3_EVENT_H

#include <df.h>
#include "device.h"

extern void
fpgaInterruptNotifyCallback(
  CoreNotification* pNotification,
  unsigned int notifyType,
  void* pCallbackContext);

#if DF_HAS_USER_EVENT_HANDLE

extern void
cleanupUserEvents(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx);

extern DfIoStatus
ioctlRegisterEvent(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);

# if DF_NEED_THUNK
extern DfIoStatus
ioctlRegisterEventThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);
#endif

extern DfIoStatus
ioctlUnregisterEvent(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);

# if DF_NEED_THUNK
extern DfIoStatus
ioctlUnregisterEventThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);
# endif

#endif

#endif
